import logging
import re
from typing import Dict, List, Tuple

import nltk
from nltk import RegexpParser

logger = logging.getLogger(__name__)


def your_solution(animal: str, doc_list: List[Dict[str, str]]) -> List[Tuple[str, int]]:
    """
    Task: Extract things that the given animal eats. These things should be mentioned in the given list of documents.
    Each document in ``doc_list`` is a dictionary with keys ``animal``, ``url``, ``title`` and ``text``, whereas
    ``text`` points to the content of the document.

    :param animal: The animal to extract diets for.
    :param doc_list: A list of retrieved documents.
    :return: A list of things that the animal eats along with their frequencies.
    """

    logger.info(f"Animal: \"{animal}\". Number of documents: {len(doc_list)}.")

    # You can directly use the following list of documents, which is a list of str, if you don't need other information (i.e., url, title).
    #title = animal
    food = {}
    documents = [doc["text"] for doc in doc_list]
    for text in documents:
        text = text.lower()
        #print('animal count:', text.count(animal))
        if(text.count(animal) >= 3):
            lines = text.split('.')
            for line in lines:
                if(line.find(' diet') != -1 or line.find(' eat') != -1 or line.find(' consume') != -1 or line.find('feed on') != -1):
                    words = nltk.word_tokenize(line)
                    pos_tags = nltk.pos_tag(words)

                    # print(pos_tags)

                    patterns = r"""chunk1:{(<NN.?>{1,2}<,>{1})+<NN.?>?<CC>?<NN.?>?}
                                        
                                    """

                    chunker = RegexpParser(patterns)
                    chunk = chunker.parse(pos_tags)

                    for a in chunk:
                        if isinstance(a, nltk.tree.Tree):
                            if a.label() == 'chunk1':
                                extract = " ".join([lf[0]
                                                   for lf in a.leaves()])
                                extract = re.sub(',', '', extract)
                                extract = re.sub('and', '', extract)
                                extract = re.sub('food', '', extract)
                                extract = re.sub('diet', '', extract)
                                extract = re.sub('water', '', extract)
                                extract = re.sub('cane', '', extract)
                                extract = re.sub(r'\s+', ' ', extract)
                                extract = extract.strip()

                                # print(extract)
                                food_items = extract.split(' ')
                                for item in food_items:
                                    if animal == 'dolphin' and item == 'lions':
                                        item = 'sea lions'
                                    if animal == 'giant panda' and item == 'sugar':
                                        item = 'sugarcane'
                                    if item in food.keys():
                                        food[item] += 1
                                    else:
                                        food[item] = 1
    keys = list(food.keys())
    for k in keys:
        if(food[k] < 5 or len(k) <= 3):
            del food[k]

    food_freq = list(zip(list(food.keys()), list(food.values())))
    # TODO Implement your own method here
    # You must extract things that are explicitly mentioned in the documents.
    # You cannot use any external CSK resources (e.g., ConceptNet, Quasimodo, Ascent, etc.).

    # Output example:
    return food_freq
